
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>基于PhalApi的DB集群拓展 V0.1bate / iVAN</title>

    <meta name="description" content="基于PhalApi的DB集群拓展 V0.1bate 前言 先在这里感谢phalapi框架创始人@dogstar,为我们提供了这样一个优秀的开源框架. 编写本次拓展出于的目的是解决大量数据写入分析的问题,也希望本拓展能对大家有些帮助,能够解决大家遇到的同样的问题. 注:V0.1bate版本,很多功能尚不完善,只提供技术交流使用,请不要用户生产环境 附上: 官网地址:http://www.phalapi.net/ 开源中国Git地址:http://git.oschina.net/dogstar/PhalApi/tree/release 1.起因 说到">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">基于PhalApi的DB集群拓展 V0.1bate</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>前言</h2>
<p><strong><em>先在这里感谢phalapi框架创始人@dogstar,为我们提供了这样一个优秀的开源框架.</em></strong></p>
<p>编写本次拓展出于的目的是解决大量数据写入分析的问题,也希望本拓展能对大家有些帮助,能够解决大家遇到的同样的问题.</p>
<p><strong>注:V0.1bate版本,很多功能尚不完善,只提供技术交流使用,请不要用户生产环境</strong></p>
<p>附上:</p>
<p>官网地址:<a href="http://www.phalapi.net/" rel="external nofollow noreferrer">http://www.phalapi.net/</a></p>
<p>开源中国Git地址:<a href="http://git.oschina.net/dogstar/PhalApi/tree/release" rel="external nofollow noreferrer">http://git.oschina.net/dogstar/PhalApi/tree/release</a></p>
<h2>1.起因</h2>
<p>说到为什么写这个拓展,起因是这样的,在和产品交流的时候他们希望可以<strong>存一些东西作为数据分析用</strong>,我考虑过hadoop但是如果说使用hadoop需要投入的成本太高了,在想有没有什么好办法的时候,想到了分表分库解决数据量大的问题,那么可以有一个封装好的服务就和操作数据库一样操作可以达到良好的分表分库的效果吗,出于这个考虑就开始这个拓展的编写.</p>
<h2>2.业务场景</h2>
<ol>
<li>大量select</p>
<p>当一个数据库需要对付大量的select请求的时候,我们往往会想到使用读写分离来解决此类问题,一个写库多个读库,一台或多台服务器用一个读库,所有的写入操作使用主库操作,应为是大量的select操作,读的压力被分配到了很多个读库实例,可以很好的解决问题大量select的问题,再者就是进行添加缓存机制的优化,这样也是能很好的解决问题</li>
<li>大量的insert
<p>对于大量insert上面所谓的读写分离完全不够看了,所有的压力全部会集中在负责写入的主库,但并不是应为并发请求的问题,问题是在于数据量大导致不管是干嘛都会慢,当数据量到了上亿的级别简直不敢想像,如果是通过分表分库(如果是4库4表也就是16张表),数据分均衡的分配到(库数量-乘-表数量)这么多张表里面从而达到解决大量数据的问题(在分表分库前面有一个主表),当然他也有缺陷就是当进行条件查询的时候最坏的条件会遍历(库数量-乘-表数量)这么多张表才能获得想要的结果,所以不是很建议用到查询列表比较平凡的应用中,当然结合缓存和读写分离可以缓解压力</li>
</ol>
<h2>3.使用拓展</h2>
<h3>3.1 下载/注册拓展</h3>
<p>大家可以到Git项目<a href="http://git.oschina.net/dogstar/PhalApi-Library" rel="external nofollow noreferrer">PhalApi Library</a>下载拓展文件,把其中的<strong>DB_Cluster</strong>文件夹复制到/PhalApi/Library目录下,如下图:</p>
<p><a href="http://i.imgur.com/CIAB9dS.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5pbWd1ci5jb20vQ0lBQjlkUy5wbmc=.jpg"></a></p>
<p>把其中的<strong>Config</strong>中的cluster.php文件放到默认的Config配置文件中</p>
<p>然后在<strong>init.php</strong>中注册以下两句话</p>
<pre><code>初始化配置文件
DI()-&gt;Cluster_DB = new Cluster_Lite(DI()-&gt;config-&gt;get('cluster'));
</code></pre>
<p>然后把框架自带的Demo文件替换成拓展自带的Demo文件如下就完成了第一步</p>
<p><a href="http://i.imgur.com/IcqUU6C.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5pbWd1ci5jb20vSWNxVVU2Qy5wbmc=.jpg"></a></p>
<h3>3.2 数据库集群初始化</h3>
<p>这里使用Mysql作为集群的数据库</p>
<p>大家可以看到拓展文件里面有一个<strong>Data/user_cluster.sql</strong> 文件,里面有一个 <strong>user_base</strong>的建表语句和另外user0,user1,user2,user3这四个表的建表语句</p>
<p>在文件里面有一些注意事项这里这里再次强调一下</p>
<pre><code>--本次集群采取4库每一库4表 4*4共16表的mysql集群(基础库不算在里面)

--基础库(id自增长,用表索引进行列表查询条件)
--库名project
--当自己建立集群mysql的时候要注意以下几点
--1.一定要注意ID要加上自动增长,这里进行的分表分库都是基于自增ID进行的,如果是自定义字符串ID需要进行算法修改,也可以使用其他缓存生成自增ID
--2.除了ID之外的字段(用于按条件查询列表ID)一定要加上索引或者是主键,不然数据量大的时候获取列表ID会很慢
--3.除了ID之外的字段一定要是更具业务需求进行查询比较频繁的,而且要保持尽量的少1-2个,大于2个建议在分出一张表做对应

--库名分表为user_cluster0,user_cluster1,user_cluster2,user_cluster3(可自定)
--下面四张表为每一个库中都拥有的4张表(注意ID不能使用自动增长)
--表名可以自定但是每个库中的表名一定要统一
--user0,user1,user2,user3
</code></pre>
<p>我这里使用结构如下(大家可以自由的配置可以2库+2表,2库+4表等都行,只需在配置文件中配置就可)</p>
<pre><code>数据库project
        -user_base表
数据库user_cluster0,user_cluster1,user_cluster2,user_cluster3
        都有以下表
        -user0,user1,user2,user3
</code></pre>
<h3>3.3 配置文件详解</h3>
<p>我们需在在默认<strong>dbs.php</strong> 数据库配置中配置链接好project库</p>
<p>然后大家看向<strong>cluster.php</strong>集群配置文件按照注释配置好自己的数据库,如果没有多个mysql实例,可以一个实例建立4个库模拟4个mysql分布式集群.</p>
<p>这里指的着重讲一下的是以下配置问题</p>
<pre><code> /**
 * 配置表
 */
'cluster' =&gt; array(
    //集群分布配置
    'list'    =&gt; array(
        'demo'  =&gt; array(
            //使用demo集群配置最大ID和最小ID,最大ID为0等于不上限
            'id_min' =&gt; 0,
            'id_max' =&gt; 0,
        ),
    ),
    //where查询条件放到衍生表中的字段
    'where'   =&gt; array(
        'city'
    ),
    //ID名称
    'id_name' =&gt; 'uId',
),
</code></pre>
<p>在list中可以配置多个集群数组KEY的名称对应配置文件上面demo集群并且可以设定ID范围,做这个设计主要是为了当我有一个2库*2表的集群,已经承载了1个亿的数据了,已经无法承担数据量了这个时候就要更换集群,在这里只需要吧demo的id_max配置成1亿,在配置一个demo1然后把id_min设定到1亿,当ID大于1亿了之后就会自己找到第二集群插入数据了(不用担心多集群了之后查询以及其他操作这里已经做好了兼容)</p>
<p>还有where属性,这里的where用于配置在user_base表中除了ID之外的索引字段能够增加查询的性能,但是尽量少应为这个会减少base表的性能,可以适当的取舍</p>
<h3>3.4 开始使用</h3>
<p>大家看向Demo的API文件中有四个接口select,delete,update,insert里面的参数都是随机生成的</p>
<p>在看向Cluster/User.php里面<strong>继承了Cluster_DB</strong>需要使用数据库集群就需要集成这个类并且实现以下两个方法</p>
<pre><code>/**
 * 获取集群实例类
 */
public function getCluster(){
    return DI()-&gt;Cluster_DB;
}

/**
 * 获取主数据库表实例
 */
public function getMainDB(){
    return DI()-&gt;notorm-&gt;user_base;
}
</code></pre>
<p><strong>getCluster</strong>方法返回在init.php中注册DI()-&gt;Cluster_DB即可,因为一个集群对应一张表可以根据需求使用不通的集群实例</p>
<p><strong>getMainDB</strong>方法是为了获取base表的实例只需要把表实例返回即可</p>
<p><strong>当做好这几件事情大家就可以尝试请求接口看看结果了</strong></p>
<h2>4. 实现思想讲解</h2>
<ol>
<li>实现架构思维</p>
<p>我在开始写这个拓展之前在想要让使用者如何去使用这个框架,怎么让使用者最方便,最后的到的答案是如果可以和正常使用Model层一样去使用的话是最好的,所以大家可以看到在Demo/Cluster/User.php中增删改查和正常使用基本没有区别.</li>
<li>分表分库算法
<p>当我们是2库2表的情况下,我们用2乘2=4然后用我们获取的ID比如55,用55%2乘2 就会得到一个小于4的数字,55得到的是3,用3/表数2=1.5取整是1表,然后用3%表数2=1,也就是存入1库1表(注意是从0开始算的)</li>
</ol>
<h2>5. 基准测试</h2>
<h3>5.1 base表基准测试</h3>
<p>因为我们的拓展是需要基于一个base表实现ID增长和where语句查询在分到集群库,所以base库需要应付的量比较大所以这里对base表进行了一次针对于不同数据量进行的单ID查询和where查询基准测试</p>
<p><strong>300w数据:</strong></p>
<p><a href="http://i.imgur.com/Qy8QDTI.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5pbWd1ci5jb20vUXk4UURUSS5wbmc=.jpg"></a></p>
<p><strong>5700w数据:</strong></p>
<p><a href="http://i.imgur.com/N5CiMHk.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5pbWd1ci5jb20vTjVDaU1Iay5wbmc=.jpg"></a></p>
<p><strong>1.3亿数据:</strong></p>
<p><a href="http://i.imgur.com/xnidxAQ.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5pbWd1ci5jb20veG5pZHhBUS5wbmc=.jpg"></a></p>
<p>明显可以看出来随着数据量的增加查询速度有明显的降低,但是到了亿级的时候还能维持到where条件查询不上0.1秒的情况还是比较理想的,最关键的是在亿级的时候插入还是相当快的所以非常适合,大量数据的写入,如果是对查询有比较大的要求的童鞋可以考虑吧5000W作为一个分界点对基础base进行划分(后期将会把此功能集成到拓展内部)</p>
<h3>5.2 从小.中.大数据库就集群与单表实际情况并发对比</h3>
<p>应为工作量比较大还在进行测试中!</p>
<h2>6. 总结</h2>
<p>在此希望本扩展能给大家带来解决实际问题的思路,第一版是bate版本请不要使用在生产环境中,如果出现问题或者是有BUG可以直接联系我<strong>QQ591235675</strong>也可加入PhalApi交流群一同交流探讨</p>
<p>注:笔者能力有限有说的不对的地方希望大家能够指出,也希望多多交流!</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-12 23:25:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%9b%86%e7%be%a4/" title="集群">集群</a>, <a href="https://www.iamivan.net/tag/%e5%a4%a7%e6%95%b0%e6%8d%ae/" title="大数据">大数据</a>, <a href="https://www.iamivan.net/tag/%e6%8b%93%e5%b1%95/" title="拓展">拓展</a>, <a href="https://www.iamivan.net/tag/phalapi/" title="phalapi">phalapi</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>基于PhalApi的DB集群拓展 V0.1bate的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7gE4p.html" rel="bookmark">PhalApi-SMS基于PhalApi容联云短信服务器拓展</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PhalApi-SMS基于PhalApi容联云短信服务器拓展 前言 在做项目时更换短信运营商时,找到了容联云通讯(滴滴用的是他的服务),感觉很不错看了下SDK文件和测试Demo感觉使用起来并不是很方便, 因为确实很多项目都会用到这一套服务比较希望好用优雅一些,所以提供了本次拓展也希望大家喜欢 附上: 官网地址:http://www.phalapi.net/ 开源中国Git地址:http://git.oschina.net/dogstar/PhalApi/tree/release 开源中国拓展Gi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPXvnDp.html" rel="bookmark">基于cloudera的BigInsights集群如何管理和应用集成系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文首先简要介绍 BigInsights 与 Cloudera 集成的相关背景,在此基础上介绍基于 cloudera 的 BigInsights 集群的系统架构,之后详细介绍在 Cloudera 之上的两种集成方式,最后介绍如何管理和应用集成系统. Cloudera 和 IBM 都是业界领先的大数据平台软件与服务提供商,2012 年 4 月,两家公司宣布在该领域建立合作关系,强强联手.Cloudera 提供了完整的 hadoop 系统,并在此基础上增强了可扩展性.稳定性和平台性能.InfoSph			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Nz70Kqb.html" rel="bookmark">基于MySQL的数据库集群系统的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql|数据|数据库 您的WebApp系统是否正在使用一个MySQL的数据库系统?您的客户是不是总是抱怨页面结果反馈的非常慢?您的MySQL系统的负载是不是总是维持在一个非常高的状态下?本文将为您提供一个分担MySQL系统的负载的方法,以及由此派生出来的一个MySQL-HA-Proxy的开发项目.使用本文提供的方法,您将以最小的源代码改动,获得MySQL系统的高效运转. 第一节 数据库集群技术的现状 目前数据库集群系统应用得比较成功,应用范围比较广泛的是:Oracle公司的Oracle9与I			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjLrgmp.html" rel="bookmark">基于redis的cas集群配置&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.cas ticket统一存储 做cas集群首先需要将ticket拿出来,做统一存储,以便每个节点访问到的数据一致.官方提供基于memcached的方案,由于项目需要,需要做计入redis,根据官方例子改了一个基于redis版本的. public class RedisTicketRegistry extends AbstractDistributedTicketRegistry{ @NotNull private final RedisTemplate&lt;String,Object&gt; rei			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXqv8Kz.html" rel="bookmark">Linux&lowbar;基于Docker搭建Redis集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说明:基于Ubuntu16.04-64bit,开始本教程前,请确保您的Linux系统已安装Docker. 步骤一:Redis镜像安装 1.下载Redis镜像 镜像中心 推荐使用网易蜂巢的镜像中心 地址:https://c.163.com/hub#/m/home/  Redis镜像 docker pull hub.c.163.com/library/redis:latest  安装完成后,使用docker images命令,查看是否安装成功 步骤二:Redis集群搭建 1.运行Redis镜像 分别			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mgw7ZAM.html" rel="bookmark">基于Kubernetes构建Docker集群管理详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在正式介绍之前,大家有必要先理解Kubernetes几个核心概念及其承担的功能.以下为Kubernetes的架构设计图: 1. Pods 在Kubernetes系统中,调度的最小颗粒不是单纯的容器,而是抽象成一个Pod,Pod是一个可以被创建.销毁.调度.管理的最小的部署单元.比如一个或一组容器. 2. Replication Controllers Replication Controller是Kubernetes系统中最有用的功能,实现复制多个Pod副本,往往一个应用需要多个Pod来支撑,并			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mg0QZZp.html" rel="bookmark">一脸懵逼学习基于CentOs的Hadoop集群安装与配置（三台机器跑集群）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1:Hadoop分布式计算平台是由Apache软件基金会开发的一个开源分布式计算平台.以Hadoop分布式文件系统(HDFS)和MapReduce(Google MapReduce的开源实现)为核心的Hadoop为用户提供了系统底层细节透明的分布式基础架构.  注意:HADOOP的核心组件有: 1)HDFS(分布式文件系统) 2)YARN(运算资源调度系统) 3)MAPREDUCE(分布式运算编程框架)       Hadoop 中的分布式文件系统 HDFS 由一个管理结点 ( NameNode			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6e8Wyb.html" rel="bookmark">【Oracle 集群】ORACLE DATABASE 11G RAC 知识图文详细教程之集群概念介绍（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				集群概念介绍 集群术语须知 服务硬件:指提供计算服务的硬件,比如 PC 机.PC 服务器. 服务实体:服务实体通常指服务软体和服务硬体. 节点(node):运行 Heartbeat 进程的一个独立主机称为节点,节点是 HA 的核心组成部分,每个节点上运行着操作系统和Heartbeat 软件服务. 资源(resource):资源是一个节点可以控制的实体,当节点发生故障时,这些资源能够被其他节点接管.如: 磁盘分区.文件系统.IP 地址.应用程序服务.共享存储 事件(event):事件也就是集群中可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr39m1p.html" rel="bookmark">Redis集群技术及Codis实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Redis集群技术及Codis实践 前言 本文主要讨论Redis集群相关技术及新发展,关于Redis运维等内容,以后另开主题讨论. 本文重点推荐Codis--豌豆荚开源的Redis分布式中间件(该项目于4个月前在GitHub开源,目前star已超过2100).其和Twemproxy相比,有诸多激动人心的新特性,并支持从Twemproxy无缝迁移至Codis. 好吧我们正式开始. 1. Redis常见集群技术 长期以来,Redis本身仅支持单实例,内存一般最多10~20GB.这无法支撑大型线上业务			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdgN1M.html" rel="bookmark" class="title">剖析 ADO&period;NET 批处理更新（深入研究数据访问）</a>
					<div>
						ado|访问|数据 ADO.NET 应用程序和基础数据源之间的交互基于一个具有双向信道的双体系结构.您可以使用各个特定于提供程序的命令或批处理更新过程来访问数据源,以读取和写入行.在这两种情况下,数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bovxgz.html" rel="bookmark" class="title">SEO实验：可能会造成百度不收录网站的几个原因</a>
					<div>
						本人的QQ类网站是本月13号上线的,从上线当天到现在已经有半个多月的时间了,可惜从上线当天到至今百度还未收录网站,对于百度一直迟迟不肯收录本人的网站,这让本人感到十公的苦恼,毕竟网站想要轻轻松松获得流 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgK38OM.html" rel="bookmark" class="title">Sybase的master库日志管理</a>
					<div>
						Sybase master 库日志满了应该如何清除呢? 可以通过以下的方法对 master库进行管理,如果确实没有足够的空间了,可以考虑对 master库进行扩容操作. 1.简单的情况下 dump t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxP0OPM.html" rel="bookmark" class="title">Android的改进版CoverFlow效果控件</a>
					<div>
						最近研究了一下如何在Android上实现CoverFlow效果的控件,其实早在2010年,就有Neil Davies开发并开源出了这个控件,Neil大神的这篇博客地址http://www.inter- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yrRrz.html" rel="bookmark" class="title">用Java实现FTP服务器解决方案</a>
					<div>
						FTP 命令 FTP 的主要操作都是基于各种命令基础之上的.常用的命令有: · 设置传输模式,它包括ASCⅡ(文本) 和BINARY 二进制模式; · 目录操作,改变或显示远程计算机的当前目录(cd. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze49k9p.html" rel="bookmark" class="title">算法：hdu 4003 Find Metal Mineral &lpar;树形背包dp&rpar;</a>
					<div>
						题意 给一棵n个节点的树, 节点编号为1~n, 每条边都有一个花费值. 有k个机器人从S点出发, 问让 机器人遍历所有边,最少花费值多少? 思路 很好的一题, 推荐! 前天看的这题, 今天才想出来的. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eLPXb.html" rel="bookmark" class="title">Focusky怎么编辑3D背景</a>
					<div>
						  Focusky怎么编辑3D背景         1.新建工程文件.打开软件,点击&quot;新建空白项目&quot;,之后选择其中一种背景色,点击&quot;确定&quot;按钮进入Focusky ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNxQwM.html" rel="bookmark" class="title">是什么造成了操作系统变慢</a>
					<div>
						  1.网卡 如果设置不当,网卡也会明显影响系统启动速度,如果你的电脑用不着网卡,那就直接将网卡拔掉,以免影响系统启动速度. 如果你的电脑连接在局域网内,安装好网卡驱动程序后,默认情况下系统会自动通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkG6gjp.html" rel="bookmark" class="title">嵌入式开发-嵌入式的底层驱动方向和上层应用方向的分析</a>
					<div>
						问题描述 嵌入式的底层驱动方向和上层应用方向的分析 刚刚得到帮助了解了方向,觉得搞嵌入式软件这两个方向其中之一,还是想进一步了解两者,以及两者的区别和学习内容,如果可以,给小弟提一点建议,谢谢 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oGwWb.html" rel="bookmark" class="title">苹果使用20年的开发语言将被Swift边缘化？对外封闭，对内开放</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 原标题:苹果使用20年的开发语言将被Swift边缘化?开发者如何看苹果的&quot;对外封闭,对内开放&quot; [IT时代周刊深度观察]北京时间6月 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZ6dab.html" rel="bookmark" class="title">Android ActionBar制作时钟实例解析&lowbar;Android</a>
					<div>
						本文实例为大家分享了Android ActionBar制作时钟的具体代码,供大家参考,具体内容如下 1. MainActivity.java   package com.example.days19a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZ4PKb.html" rel="bookmark" class="title">关于计算机字符编码的问题！</a>
					<div>
						问题描述 关于计算机字符编码的问题! 计算机字符编码一直困扰我,真希望有大牛帮我解惑: 1. 输入法在输入文本的时候其实是输入对应字符编码集的对应字符的二进制编码,那么这时如果要保存,只需要保存这些二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bam1Enb.html" rel="bookmark" class="title">android-如何从微博中点击别人分享的淘宝商品链接的启动淘宝？</a>
					<div>
						问题描述 如何从微博中点击别人分享的淘宝商品链接的启动淘宝? 需求是:我点击新浪微博别人分享的淘宝商品链接,启动淘宝app 解决方案 用PackageManager跳到淘宝中,但是你要去找找淘宝的包名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlq7Qb.html" rel="bookmark" class="title">mybatis-Mybatis操作Oracle数据库：批量修改成功后返回的值是-1？</a>
					<div>
						问题描述 Mybatis操作Oracle数据库:批量修改成功后返回的值是-1? Mapper.xml &lt;update id=&quot;updateByMultiConditions&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmvxLz.html" rel="bookmark" class="title">android开发的准备工作</a>
					<div>
						问题描述 android开发的准备工作 初次接触安卓开发,想知道提前要做什么准备?比如搭建环境等方面 请大神帮忙 解决方案 1.首先就是搭建环境咯(java:需要安装JDK,需要一份API,ADT,E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7GKkM.html" rel="bookmark" class="title">mapx控件鼠标滚轮</a>
					<div>
						问题描述 问题:请教各位,mapx控件做gis,如何分别实现1.鼠标滚轮也可用于移动地图,滑动滚轮可以上下移动地图,类似mipantool工具2.鼠标滚轮实现放大.缩小电子地图谢谢,最好提供例子. 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL56np.html" rel="bookmark" class="title">MySQL记</a>
					<div>
						备份数据库的策略: 1. 使用mysqldump定期完整备份每一个数据库: 2. 开启二进制日志定期增量备份每一个数据库. 恢复数据库的策略: 1. 使用mysql导入最后一次的完整备份. 2. 使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKPAOb.html" rel="bookmark" class="title">DedeCMS曝SQL注入漏洞 360提醒站长速打补丁</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 近日,知名第三方漏洞报告平台乌云曝光建站工具DedeCMS系统反馈页面存在SQL注入高危漏洞(http://www.wooyun.org/bugs/wo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AQO9z.html" rel="bookmark" class="title">沪、深交易所&OpenCurlyDoubleQuote;快马加鞭&rdquo;</a>
					<div>
						两大交易所都在为新股开闸做最后的准备工作. 6月17日,沪深两大交易所同时对原来的&quot;资金申购上网定价公开发行股票办法&quot;(下面简称&quot;资金申购办法&quot;)和&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYJ7Zp.html" rel="bookmark" class="title">ftp-Response OutputStream 输出图片</a>
					<div>
						问题描述 Response OutputStream 输出图片 try{ int reply; ftpClient.connect(ip,Integer.parseInt(port)); ftpCli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAVROb.html" rel="bookmark" class="title">《MongoDB管理与开发精要》&mdash;&mdash;2&period;7节本章小结</a>
					<div>
						2.7 本章小结 本章介绍了MongoDB的基本结构,包括如何存储数据.数据文件是如何增长的.各种数据类型以及何时使用这些数据类型,同时,对MongoDB的安装和配置问题进行了详细的介绍,并且举例说明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22GYQb.html" rel="bookmark" class="title">文本框的传值问题</a>
					<div>
						问题描述 例如我有三个文本框,在前两个文本框内输入数字后什么也不做,第三个文本框自动出现前两个数字相加的和我是新手,谢谢大家帮我,解决后马上给分 解决方案 解决方案二:js解决functionMyTo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8AXjb.html" rel="bookmark" class="title">struts2批量删除示例</a>
					<div>
						问题描述 需要一个struts2批量删除示例,在批量删除块不是很懂 解决方案 解决方案二:1.查询的时候把每条数据的ID绑定在CheckBox上:2.选择删除--利用JS对选中的CheckBox对象获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNkPQp.html" rel="bookmark" class="title">浅析BootStrap Treeview的简单使用&lowbar;javascript技巧</a>
					<div>
						bootstrap-treeview.js1是一款强大的树菜单插件,本文给大家介绍bootstrap treeview的简单使用. 废话不多说,直接上干干货. 1.bootstrap-treeview ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr25NjM.html" rel="bookmark" class="title">php数字每三位加逗号的功能函数&lowbar;php技巧</a>
					<div>
						php实现数字格式化,数字每三位加逗号的功能函数,具体代码如下: function num_format($num){ if(!is_numeric($num)){ return false; } $ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlaVAp.html" rel="bookmark" class="title">Chrome中模态对话框showModalDialog返回值问题的解决方法&lowbar;javascript技巧</a>
					<div>
						没有找到太好的解决办法,暂时处理方法是,在弹出窗口中同时给 window.opener.ReturnValue 赋返回值.这样在关闭窗口后,通过下面的代码取得返回值: 复制代码 代码如下: var v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdGJ4M.html" rel="bookmark" class="title">商务部发布的网购新规太过于前瞻性</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 允许消费者一段时间内无理由取消订单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boq58Ep.html" rel="bookmark" class="title">asp&period;net TreeView的问题！ 救命！</a>
					<div>
						问题描述 asp.net中treeview上绑定的是站点地图的数据.我现在想要点击某一个节点的时候触发事件.我是写在selectnodechanged事件中的{if(this.treeview1.se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdvQA2b.html" rel="bookmark" class="title">智能硬件比拼创意&comma;愚人节让科技公司玩个够</a>
					<div>
						DoNews 4月1日消息 每年愚人节各大科技公司都玩得很High,策划了各种以假乱真或是诙谐幽默的愚人节玩笑,今年也不例外.从今日推出的产品来看,智能硬件最为火爆,成为了各大科技公司&quot;意淫 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAE3Dp.html" rel="bookmark" class="title">《嵌入式设备驱动开发精解》&mdash;&mdash;1&period;2 关于本教程涉及的实例</a>
					<div>
						1.2 关于本教程涉及的实例 嵌入式设备驱动开发精解在后续的章节中会经常提及实例这个词,此处的实例指的是我们进行开发实验的一整套包括软件.硬件的整体开发和调试环境,软件方面的开发环境可以依据后续章节中 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
